unit zcligne_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons,
  Math;

const
  Version_ = 'Atténuateur résistif  - v1.3.7 by Didier GERARD';

type

  { TWdMain }

  TWdMain = class(TForm)
    Edit1: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    Edit7: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Edit12: TEdit;
    Edit8: TEdit;
    Edit9: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label10: TLabel;
    Label13: TLabel;
    Label12: TLabel;
    Label11: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    Panel10: TPanel;
    Panel18: TPanel;
    Panel22: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel12: TPanel;
    Panel16: TPanel;
    Panel2: TPanel;
    Panel13: TPanel;
    Panel21: TPanel;
    Panel23: TPanel;
    Panel24: TPanel;
    Panel25: TPanel;
    Panel26: TPanel;
    Panel27: TPanel;
    Panel28: TPanel;
    Panel29: TPanel;
    Panel3: TPanel;
    Panel11: TPanel;
    Panel20: TPanel;
    Panel17: TPanel;
    Panel30: TPanel;
    Panel31: TPanel;
    Panel32: TPanel;
    Panel33: TPanel;
    Panel4: TPanel;
    Panel6: TPanel;
    Panel5: TPanel;
    Panel19: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure Edit12KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure Edit7KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;

implementation

uses ZcLigne_RColor;

{$R *.lfm}

{ TWdMain }

const
  NeperE = 2.718281828459045235360287471352;
  // 1 db= 0,1151...
  UndB = 0.11512925465056432714486211849794;

function Convert_Virgule(s: string): string;
var
  St: string;
  n: integer;
begin
  St := s;
  for n := 1 to Length(St) do
    if St[n] = ',' then
      St[n] := '.';
  Result := St;
end;

function Str_Real(s: string): real;
var
  t: string;
  r: real;
  n, p: integer;
begin
  r := 0;
  if s <> '' then
  begin
    t := s;
    n := 0;
    for p := 1 to Length(t) do
      case t[p] of
        '0'..'9': Inc(n);
        ',': Inc(n);
        '.':
        begin
          t[p] := ',';
          Inc(n);
        end;
      end;
    if n = Length(t) then
    begin
      if s[Length(t)] = ',' then
        t := t + '0';
      r := StrToFloat(t);
    end;
  end;
  Result := r;
end;

function StrToReal(Chaine: string): real;
var
  r: real;
  Pos: integer;
begin
  Val(Chaine, r, Pos);
  if Pos > 0 then
    Val(Copy(Chaine, 1, Pos - 1), r, Pos);
  Result := r;
end;

function RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //avec 2 décimales
  Result := s;
end;

function If_Chiffre(s: string): boolean;
var
  n, Lg, Ch, Vi, Au: integer;
begin
  if (s = '') or (s = '0') then
  begin
    Result := False;
  end
  else
  begin
    Lg := Length(s);
    Ch := 0;
    Vi := 0;
    Au := 0;
    for n := 1 to Lg do
    begin
      if s[n] in ['0'..'9'] then
      begin
        Inc(Ch);
      end
      else
      begin
        if s[n] = '.' then
          Inc(Vi)
        else
          Inc(Au);
      end;
    end;
    if (Au = 0) and (Vi < 2) then
      Result := True
    else
      Result := False;
  end;
end;

function Racine_de_L_sur_C: real;
var
  L, C, R: real;
begin
  with WdMain do
  begin
    //Zc 2 fils
    //Zc = Racine(L/C) * Rho
    //L=650 µH
    L := 650 / 1000000;
    Edit1.Text := FloatToStrF(L, ffExponent, 3, 2);
    //C=50 nFarad
    C := 50 / 1000000000;
    //Edit6.Text:=FloatToStr(C);
    Edit2.Text := FloatToStrF(C, ffExponent, 3, 2);
    R := Sqrt(L / C); //114,02
    Edit3.Text := FloatToStrF(R, ffFixed, 8, 3);
  end;
  Result := R;
end;

function Frequence_Caracteristique: real;
var
  s: string;
  f: real;
begin
  with WdMain do
  begin
    f := 300000;
    //Saisie en Hz
    s := Edit12.Text;
    s := Convert_Virgule(s);
    if If_Chiffre(s) then
    begin
      //ShowmEssage('  La fréquence doit être supérieure à zéro.');
      f := StrToReal(s);
    end;
    Edit12.Text := RealToStr(f, 2);
  end;
  Result := f;
end;

function Zc_6_10: real;
var
  Zc, Rho: real;
  R_6_10, L: real;
  R2Fils, Omega: real;
begin
  with WdMain do
  begin
    //Zc 2 fils
    //Zc = Racine(L/C) * Rho
    //Rho = Racine(1+(R²/L²Oméga²))
    //Oméga=2*PI*Frequence caractéristique
    R2Fils := Racine_de_L_sur_C;
    //R pour du câble 6/10
    //R=1,26*10^-3*Racine(Fc/5,65*10^7)*(1/0,6*10^-3*Racine(1-0,99745))
    //Les valeurs ne correspondent pas avec la formule...
    R_6_10 := 994;
    Edit4.Text := FloatToStr(R_6_10);
    //Rho=Racine(1+(R_6_10²/(L²*Omega)²
    Omega := 2 * PI * Frequence_Caracteristique;
    //L=650 µH
    L := 650 / 1000000;
    //Rho:=Sqrt(1+(Sqr(R_6_10²)/(L*Omega)));
    Rho := Sqrt(1 + (Sqr(R_6_10) / (Sqr(Omega * L))));
    Edit5.Text := FloatToStrF(Rho, ffFixed, 8, 3);
    //Zc:=Racine(L/C)*Racine(Rho)
    Zc := R2Fils * Sqrt(Rho);
    //Zc
    Edit6.Text := FloatToStrF(Zc, ffFixed, 8, 3);
    ActiveControl := Edit7;
  end;
  Result := Zc;
end;

procedure Calcul_Cellule;
var
  s: string;
  Z1, Z2, Zc, dB, Lambda: extended;
begin
  with WdMain do
  begin
    s := Edit7.Text;
    if (s = '') or (s = '0') then
    begin
      //Z1
      Panel3.Caption := '';
      Panel4.Caption := '';
      Panel5.Caption := '';
      Panel6.Caption := '';
      //Z2
      Panel7.Caption := '';
    end
    else
    begin
      if If_Chiffre(s) then
      begin
        dB := Str_Real(s);
        if dB > 0 then
        begin
          //Lambda
          Lambda := dB * UndB;
          Panel2.Caption := s + ' dB';
          //Zc
          Zc := Zc_6_10;
          Edit11.Text := FloatToStrF(Lambda, ffFixed, 8, 3);
          //Z1:=2*Zc*TanH(Lambda/2)
          Z1 := 2 * Zc * Tanh(Lambda / 2);
          Edit8.Text := FloatToStrF(Z1, ffFixed, 8, 3);
          //Z1/4
          Z1 := Z1 / 4;
          Edit9.Text := FloatToStrF(Z1, ffFixed, 8, 3);
          s := FloatToStr(Z1);
          if Length(s) > 5 then
            s := Copy(s, 1, 5);
          s := s + ' ohms';
          //Affichage Z1/4
          Panel3.Caption := s;
          Panel4.Caption := s;
          Panel5.Caption := s;
          Panel6.Caption := s;
          //Z2=Zc/Sinh(Lambda)
          Z2 := Zc / Sinh(Lambda);
          Edit10.Text := FloatToStrF(Z2, ffFixed, 8, 3);
          s := FloatToStr(Z2);
          if Length(s) > 5 then
            s := Copy(s, 1, 5);
          s := s + ' ohms';
          Panel7.Caption := s;
        end;
      end
      else
        ShowMessage('   Entrez un chiffre valide.   ');
    end;
  end;
end;

procedure TWdMain.Edit7KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key = 13 then
    Calcul_Cellule;
end;

procedure TWdMain.Edit12KeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  if Key = 13 then
    Calcul_Cellule;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Calcul_Cellule;
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
  WdRColor.Show;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  WdMain.Caption := Version_;
  Calcul_Cellule;
  ActiveControl := Edit7;
end;

end.
